using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using UnityEngine;

/// <summary>
/// Manages the generation of an mesh from vtk or .elem/.pts/.igb files
/// </summary>
[RequireComponent(typeof(MeshFilter))]
public class MeshGenerator : MonoBehaviour
{
    // Locally stored filenames and paths
    public string filename = "Data/";
    public string voltageDataPath;
    //Scale to which the mesh is scaled
    //Factor to which the model is downscaled
    public int downScale = 100000;
    //False if animation should not be drawn. Only for debugging/developing use
    public bool drawAnimation = true;
    //The generated mesh
    private Mesh mesh;
    private List<Vector3> vertices = new();
    private List<int> triangles = new();
    private int offsetCounter = 0;
    private int lastOffset = 0;
    private readonly List<String> allowedElements = new() { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10","101","103" };
    private MeshColor colorGen;
    private ElementParser elemParser;

    void Start()
    {
        UpdatePaths();
        transform.parent.gameObject.transform.localScale = new Vector3(1f / downScale, 1f / downScale, 1f / downScale);

        colorGen = GetComponent<MeshColor>();
    }

    /// <summary>
    /// Updates the mesh and the animation data for the given mesh.
    /// Uses PlayerPrefs which store the current file paths
    /// </summary>
    /// <returns></returns>
    public async Task UpdateMeshAndAnimation()
    {
        if (PlayerPrefs.HasKey(Constants.dataDirectory) && PlayerPrefs.HasKey(Constants.animationFilePath))
        {

            await UpdateAndGenerateNewMeshWithAnimation();
        }
        else
        {
            StatusManager.Instance.SetStatus("No path to animation and mesh data set");
        }

    }


    /// <summary>
    /// Updates only the animation data for the mesh and not the structure
    /// </summary>
    /// <returns></returns>
    public async Task UpdateAnimationData()
    {
        if (drawAnimation)
        {
            UpdatePaths();
            StatusManager.Instance.SetStatus("Started Reading elements from " + voltageDataPath);
            await colorGen.ReadAnimationFile(voltageDataPath);
            StatusManager.Instance.SetStatus("Finished reading elem file; starting processing");
            await colorGen.CreateAnimationForIGBFile(mesh);
            StatusManager.Instance.SetStatus("Finished Calculating Colors");
        }
    }

    /// <summary>
    /// Updates the currently stored paths for the animation files from the PlayerPrefs storage into the locally used variables
    /// </summary>
    public void UpdatePaths()
    {
        filename = PlayerPrefs.GetString(Constants.dataDirectory, filename);
        voltageDataPath = PlayerPrefs.GetString(Constants.animationFilePath, voltageDataPath);
    }


    /// <summary>
    /// Updates the structure of a given mesh. Also calls an update for the animation
    /// Therefore selects between .vtk and carp type files
    /// </summary>
    /// <returns></returns>
    private async Task UpdateAndGenerateNewMeshWithAnimation()
    {
        UpdatePaths();
        mesh = new Mesh();
        GetComponent<MeshFilter>().mesh = mesh;

        if (filename.EndsWith(".vtk"))
        {
            ReadVTKFile();
        }
        else
        {
            await ReadCarpFolder();
        }

        UpdateMesh();

        //Updates the bounds for the mesh, used to generate the center point and collisions
        Bounds meshBounds = mesh.bounds;
        StatusManager.Instance.SetStatus("Updating bounds");
        UpdateCenter(meshBounds);
        StatusManager.Instance.SetStatus("Finished updating bounds");

        //Updates the mesh collider for checking for collisions. Used for marking on the mesh
        GetComponent<MeshCollider>().sharedMesh = mesh;

        await UpdateAnimationData();

    }

    /// <summary>
    /// Reads in a folder which was generated by exporting the mesh from openCarp
    /// Should include .pts (Points) and .elem (Only triangles are used) Files to build the mesh
    /// </summary>
    /// <returns></returns>
    private async Task ReadCarpFolder()
    {
        foreach (var file in new DirectoryInfo(filename).GetFiles())
        {
            if (file.Name.EndsWith(".pts"))
            {
                await ParsePTSFile(file.FullName);

            }
            else if (file.Name.EndsWith(".elem"))
            {
                await ParseElemFile(file.FullName);
            }
        }
    }

    /// <summary>
    /// Moves the mesh to move the pivot-point of the mesh to the mid point of the mesh
    /// Allows for better rotation
    /// </summary>
    /// <param name="meshBounds">Bounds of the aabb of the mesh</param>
    private void UpdateCenter(Bounds meshBounds)
    {
        Vector3 scaleFactor = new(-0.5f, -0.5f, -0.5f);
        transform.localPosition = Vector3.Scale((meshBounds.max - meshBounds.min), scaleFactor) - meshBounds.min;
    }


    /// <summary>
    /// Parses an .elm file which includes the planes of an mesh. This method only uses triangles to be better optimized with the GPU
    /// Also sets the current status to the given status label
    /// </summary>
    /// <param name="path">Path of the .elm file</param>
    /// <returns></returns>
    private async Task ParseElemFile(string path)
    {
        elemParser = new ElemFileParser(allowedElements);
        await elemParser.Parse(path);
        triangles = elemParser.ReadInElements;

    }


    /// <summary>
    /// Parses an .pts File which includes all vertices for the responding mesh
    /// </summary>
    /// <param name="path">Path to the .pts file</param>
    /// <returns></returns>
    private async Task ParsePTSFile(string path)
    {
        PTSParser ptsParser = new PTSParser();
        await ptsParser.Parse(path);
        vertices = ptsParser.ReadInPoints;
    }


    /// <summary>
    /// Updates the mesh with the parsed vertices and triangles
    /// </summary>
    void UpdateMesh()
    {
        StatusManager.Instance.SetStatus("Start updating mesh");
        mesh.Clear();
        mesh.vertices = vertices.ToArray();
        mesh.triangles = triangles.ToArray();
        Debug.Log("Number of Vertices: " + vertices.Count());
        Debug.Log("Number of Triangles: " + triangles.Count / 3);
        StatusManager.Instance.SetStatus("Finished updating mesh");
    }

    //////////////////////////////////////VTK STUFF NOT MAINTAINED///////////////


    /// <summary>
    /// Reads in VTK files and converts them into an mesh for unity
    /// Currently not used an maintained because .elem and .pts files were preferred
    /// </summary>
    private void ReadVTKFile()
    {
        bool points = false;
        bool types = false;
        bool cells = false;
        bool connectivity = false;
        bool offsets = false;
        int type5Count = 0;
        StreamReader inp_stream = new(filename);
        StatusManager.Instance.SetStatus("Reading mesh file " + filename);
        while (!inp_stream.EndOfStream)
        {
            string line = inp_stream.ReadLine();

            if (line == "" || char.IsLetter(line[0]))
            {
                points = types = cells = connectivity = offsets = false;
            }
            if (line.StartsWith("POINTS"))
            {
                points = true;
            }
            else if (line.StartsWith("CELL_TYPES"))
            {
                points = false;
                types = true;
            }
            else if (line.StartsWith("CELLS"))
            {
                cells = true;
                types = points = false;
                print("The number of defined Triangles is: " + type5Count);
            }
            else if (line.StartsWith("CELL_DATA"))
            {
                cells = false;
            }
            else if (line.StartsWith("CONNECTIVITY"))
            {
                connectivity = true;
                types = points = false;
                print("Number of offsets is" + offsetCounter);
            }
            else if (line.StartsWith("OFFSETS"))
            {
                offsets = true;
            }


            if (points)
            {
                //Check if line starts with a number
                if (line.Length > 5 && (char.IsDigit(line[0]) || line[0].Equals('-')))
                {
                    string[] sArray = line.Split(' ');
                    if (sArray.Length < 6)
                    {
                        vertices.Add(ArrayToVertex(sArray));
                    }
                    else
                    {
                        vertices.Add(ArrayToVertex(sArray[0..3]));
                        if (sArray.Length >= 6)
                        {
                            vertices.Add(ArrayToVertex(sArray[3..6]));
                        }
                        if (sArray.Length >= 9)
                            vertices.Add(ArrayToVertex(sArray[6..9]));
                    }
                }
            }
            else if (types)
            {
                if (line.Length > 0 && line[0] == '5')
                {
                    type5Count++;
                }
            }
            else if (cells || connectivity)
            {
                if (line.StartsWith("OFFSETS"))
                {
                    //Only offset definition, use CONNECTIVITY Field
                    cells = false;
                }
                string[] sArray = line.Split(' ');
                //Render only triangles to work with meshes
                List<int> triangle = ArrayToTriangleVTK(sArray);
                if (triangle.Count % 3 != 0)
                {
                    //Triangles have to have 3 vertices
                    print("No real triangle at input: " + line);

                }
                else
                {
                    //concatenate Lists
                    triangles.AddRange(triangle);
                }

            }
            else if (offsets)
            {
                HandleOffsets(line.Split(' '));
            }
        }
        inp_stream.Close();
    }


    /// <summary>
    /// Method to check if the offsets of a vtk file are in equidistant distances
    /// </summary>
    /// <param name="sArray"></param>
    void HandleOffsets(string[] sArray)
    {
        foreach (string s in sArray)
        {
            if (s != "")
            {
                if (int.TryParse(s, out int output))
                {
                    if (output - lastOffset != 3)
                    {
                        print("Offset difference was not 3" + sArray);
                    }
                    lastOffset = output;
                    offsetCounter++;
                    if (output % 3 != 0)
                    {
                        print(sArray);
                    }
                }
            }
        }
    }


    /// <summary>
    /// Converts an string array into a vertex (float Vector3)
    /// </summary>
    /// <param name="sArray"></param>
    /// <returns></returns>
    Vector3 ArrayToVertex(string[] sArray)
    {
        Vector3 newVertex = new Vector3(
            float.Parse(sArray[0], CultureInfo.InvariantCulture),
            float.Parse(sArray[2], CultureInfo.InvariantCulture),
            float.Parse(sArray[1], CultureInfo.InvariantCulture)) / downScale;
        return newVertex;
    }

    /// <summary>
    /// Converts an already split VTK line into triangles (could be 1 to 3 per line, depending on the format)
    /// </summary>
    /// <param name="sArray">A line of the VTK file split by spaces</param>
    /// <returns></returns>
    List<int> ArrayToTriangleVTK(string[] sArray)
    {
        //Old Notation
        if (sArray[0].StartsWith("3") && sArray.Length < 5)
        {
            //Removes first number, because this is the number of elements of an shape
            sArray = sArray.Skip(1).ToArray();
            List<int> triangle = new();
            for (int i = 0; i < 3; i++)
            {

                //Prohibits spaces from ruining the code
                if (int.TryParse(sArray[i], out int output))
                {
                    triangle.Add(output);
                }
            }
            return triangle;
        }
        else
        {
            //New notation: Multi-cell data
            List<int> triangle = new();
            foreach (String s in sArray)
            {
                if (s == "")
                {
                    continue;
                    //Skip if s is empty
                }
                if (int.TryParse(s, out int output))
                {
                    triangle.Add(output);
                }
                else
                {
                    print("Parsing: " + s + " as triangle vertex was not possible");
                }

            }
            return triangle;
        }

    }
}
